using Exferia_Aplicacion.General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using System.Runtime.CompilerServices;
using Exferia_Mythos.General;
using Exferia_General;
using Exferia_Mythos._0_Modelos;
using Exferia_EntityFramework;

namespace Exferia_Mythos._3_Vistas.Listados
{
    public class ABS_Listado_MYT_Partes_ProtocolosRellenos : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_MYT_Partes_ProtocolosRellenos()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //idProtocolo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo.Protocolo_Id),new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true,nameof(INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo.Protocolo_Id),"id", Enumerados.G_ENUM_TIPOSDATOS.LONG,true,0,false,false,true,false, "" , null));

            //Protocolo
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_PROTOCOLO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo.Protocolo_Id), nameof(MYT_Protocolos), nameof(MYT_Protocolos.id), nameof(MYT_Protocolos.codigo), nameof(MYT_Protocolos.descripcion), nameof(MYT_Protocolos.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo.Protocolo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo.Protocolo), "Protocolo", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, true, true, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_PROTOCOLO));

            //Tipo
            INTERNO_Filtro_Opciones_Modelo mdl_INTERNO_Filtro_Opciones_Modelo_TIPO = new INTERNO_Filtro_Opciones_Modelo();
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPO.MULTISELECCION = true;
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPO.LISTADO = new List<INTERNO_Filtro_Opciones_Listado_Modelo>();
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPO.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables_Mythos.G_MDL_PROTOCOLOSRELLENOS_POR_TIPOPARTE.Descripcion, Variables_Mythos.G_MDL_PROTOCOLOSRELLENOS_POR_TIPOPARTE.Descripcion));
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPO.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables_Mythos.G_MDL_PROTOCOLOSRELLENOS_POR_MODELO.Descripcion, Variables_Mythos.G_MDL_PROTOCOLOSRELLENOS_POR_MODELO.Descripcion));
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPO.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables_Mythos.G_MDL_PROTOCOLOSRELLENOS_POR_PLANMANTENIMIENTO.Descripcion, Variables_Mythos.G_MDL_PROTOCOLOSRELLENOS_POR_PLANMANTENIMIENTO.Descripcion));
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPO.TIPO = 1;
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo.Tipo_Texto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo.Tipo_Texto), "Tipo", Enumerados.G_ENUM_TIPOSDATOS.OPCIONES, false, 90, true, true, true, false, "", null, false, mdl_INTERNO_Filtro_Opciones_Modelo_TIPO));
        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_MYT_PARTES_PROTOCOLOSRELLENOS);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_MYT_PARTES_PROTOCOLOSRELLENOS;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_MYT_Partes_ProtocolosRellenos_Listado_Modelo.Protocolo);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
